import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { createVNode as _createVNode } from "vue";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import { isEmptyElement, initDefaultProps, flattenChildren, isValidElement } from '../_util/props-util';
import { cloneElement } from '../_util/vnode';
import { collapseProps } from './commonProps';
import { getDataAndAriaProps } from '../_util/util';
import { computed, defineComponent, ref, toRef, watch } from 'vue';
import RightOutlined from "@ant-design/icons-vue/es/icons/RightOutlined";
import firstNotUndefined from '../_util/firstNotUndefined';
import classNames from '../_util/classNames';
import useConfigInject from '../config-provider/hooks/useConfigInject';
import collapseMotion from '../_util/collapseMotion';
// CSSINJS
import useStyle from './style';
import devWarning from '../vc-util/devWarning';
import CollapsePanel from './CollapsePanel';
import useSize from '../config-provider/hooks/useSize';
function getActiveKeysArray(activeKey) {
  let currentActiveKey = activeKey;
  if (!Array.isArray(currentActiveKey)) {
    const activeKeyType = typeof currentActiveKey;
    currentActiveKey = activeKeyType === 'number' || activeKeyType === 'string' ? [currentActiveKey] : [];
  }
  return currentActiveKey.map(key => String(key));
}
export { collapseProps };
export default defineComponent({
  compatConfig: {
    MODE: 3
  },
  name: 'ACollapse',
  inheritAttrs: false,
  props: initDefaultProps(collapseProps(), {
    accordion: false,
    destroyInactivePanel: undefined,
    destroyOnHidden: undefined,
    bordered: true,
    expandIconPosition: 'start'
  }),
  slots: Object,
  setup(props, {
    attrs,
    slots,
    emit
  }) {
    devWarning(props.destroyInactivePanel === undefined, 'Collapse', '`destroyInactivePanel` is deprecated. Please use `destroyOnHidden` instead.');
    const stateActiveKey = ref(getActiveKeysArray(firstNotUndefined([props.activeKey, props.defaultActiveKey])));
    watch(() => props.activeKey, () => {
      stateActiveKey.value = getActiveKeysArray(props.activeKey);
    }, {
      deep: true
    });
    const {
      prefixCls,
      direction,
      rootPrefixCls
    } = useConfigInject('collapse', props);
    // style
    const [wrapSSR, hashId] = useStyle(prefixCls);
    const iconPosition = computed(() => {
      const {
        expandIconPosition
      } = props;
      if (expandIconPosition !== undefined) {
        return expandIconPosition;
      }
      return direction.value === 'rtl' ? 'end' : 'start';
    });
    const renderExpandIcon = panelProps => {
      const {
        expandIcon = slots.expandIcon
      } = props;
      const icon = expandIcon ? expandIcon(panelProps) : _createVNode(RightOutlined, {
        "rotate": panelProps.isActive ? 90 : undefined
      }, null);
      return _createVNode("div", {
        "class": [`${prefixCls.value}-expand-icon`, hashId.value],
        "onClick": () => ['header', 'icon'].includes(props.collapsible) && onClickItem(panelProps.panelKey)
      }, [isValidElement(Array.isArray(expandIcon) ? icon[0] : icon) ? cloneElement(icon, {
        class: `${prefixCls.value}-arrow`
      }, false) : icon]);
    };
    const setActiveKey = activeKey => {
      if (props.activeKey === undefined) {
        stateActiveKey.value = activeKey;
      }
      const newKey = props.accordion ? activeKey[0] : activeKey;
      emit('update:activeKey', newKey);
      emit('change', newKey);
    };
    const onClickItem = key => {
      let activeKey = stateActiveKey.value;
      if (props.accordion) {
        activeKey = activeKey[0] === key ? [] : [key];
      } else {
        activeKey = [...activeKey];
        const index = activeKey.indexOf(key);
        const isActive = index > -1;
        if (isActive) {
          // remove active state
          activeKey.splice(index, 1);
        } else {
          activeKey.push(key);
        }
      }
      setActiveKey(activeKey);
    };
    const getNewChild = (child, index) => {
      var _a, _b, _c;
      if (isEmptyElement(child)) return;
      const activeKey = stateActiveKey.value;
      const {
        accordion,
        destroyInactivePanel,
        destroyOnHidden,
        collapsible,
        openAnimation
      } = props;
      const animation = openAnimation || collapseMotion(`${rootPrefixCls.value}-motion-collapse`);
      // If there is no key provide, use the panel order as default key
      const key = String((_a = child.key) !== null && _a !== void 0 ? _a : index);
      const {
        header = (_c = (_b = child.children) === null || _b === void 0 ? void 0 : _b.header) === null || _c === void 0 ? void 0 : _c.call(_b),
        headerClass,
        collapsible: childCollapsible,
        disabled
      } = child.props || {};
      let isActive = false;
      if (accordion) {
        isActive = activeKey[0] === key;
      } else {
        isActive = activeKey.indexOf(key) > -1;
      }
      let mergeCollapsible = childCollapsible !== null && childCollapsible !== void 0 ? childCollapsible : collapsible;
      // legacy 2.x
      if (disabled || disabled === '') {
        mergeCollapsible = 'disabled';
      }
      const newProps = {
        key,
        panelKey: key,
        header,
        headerClass,
        isActive,
        prefixCls: prefixCls.value,
        destroyOnHidden: destroyOnHidden !== null && destroyOnHidden !== void 0 ? destroyOnHidden : destroyInactivePanel,
        openAnimation: animation,
        accordion,
        onItemClick: mergeCollapsible === 'disabled' ? null : onClickItem,
        expandIcon: renderExpandIcon,
        collapsible: mergeCollapsible
      };
      return cloneElement(child, newProps);
    };
    const convertItemsToNodes = (items, props) => {
      const {
        prefixCls,
        accordion,
        collapsible,
        destroyOnHidden,
        onItemClick,
        activeKey,
        expandIcon,
        openAnimation
      } = props;
      return items.map((item, index) => {
        const {
            children,
            label,
            key: rawKey,
            collapsible: rawCollapsible,
            onItemClick: rawOnItemClick,
            destroyOnHidden: rawDestroyOnHidden
          } = item,
          restProps = __rest(item, ["children", "label", "key", "collapsible", "onItemClick", "destroyOnHidden"]);
        // You may be puzzled why you want to convert them all into strings, me too.
        // Maybe: https://github.com/react-component/collapse/blob/aac303a8b6ff30e35060b4f8fecde6f4556fcbe2/src/Collapse.tsx#L15
        const key = String(rawKey !== null && rawKey !== void 0 ? rawKey : index);
        const mergeCollapsible = rawCollapsible !== null && rawCollapsible !== void 0 ? rawCollapsible : collapsible;
        const mergedDestroyOnHidden = rawDestroyOnHidden !== null && rawDestroyOnHidden !== void 0 ? rawDestroyOnHidden : destroyOnHidden;
        const handleItemClick = value => {
          if (mergeCollapsible === 'disabled') {
            return;
          }
          onItemClick(value);
          rawOnItemClick === null || rawOnItemClick === void 0 ? void 0 : rawOnItemClick(value);
        };
        let isActive = false;
        if (accordion) {
          isActive = activeKey[0] === key;
        } else {
          isActive = activeKey.indexOf(key) > -1;
        }
        const animation = openAnimation || collapseMotion(`${rootPrefixCls.value}-motion-collapse`);
        return _createVNode(CollapsePanel, _objectSpread(_objectSpread({}, restProps), {}, {
          "prefixCls": prefixCls,
          "key": key,
          "panelKey": key,
          "isActive": isActive,
          "accordion": accordion,
          "expandIcon": expandIcon,
          "header": label,
          "collapsible": mergeCollapsible,
          "onItemClick": handleItemClick,
          "destroyOnHidden": mergedDestroyOnHidden,
          "openAnimation": animation
        }), {
          default: () => [children]
        });
      });
    };
    const getItems = () => {
      var _a, _b;
      if (Array.isArray(props.items)) {
        return convertItemsToNodes(props.items, {
          prefixCls: prefixCls.value,
          accordion: props.accordion,
          expandIcon: renderExpandIcon,
          collapsible: props.collapsible,
          destroyOnHidden: (_a = props.destroyOnHidden) !== null && _a !== void 0 ? _a : props.destroyInactivePanel,
          onItemClick: onClickItem,
          activeKey: stateActiveKey.value,
          openAnimation: props.openAnimation
        });
      }
      return flattenChildren((_b = slots.default) === null || _b === void 0 ? void 0 : _b.call(slots)).map(getNewChild);
    };
    const mergedSize = useSize(toRef(props, 'size'));
    return () => {
      const {
        accordion,
        bordered,
        ghost
      } = props;
      const collapseClassName = classNames(prefixCls.value, {
        [`${prefixCls.value}-borderless`]: !bordered,
        [`${prefixCls.value}-icon-position-${iconPosition.value}`]: true,
        [`${prefixCls.value}-rtl`]: direction.value === 'rtl',
        [`${prefixCls.value}-ghost`]: !!ghost,
        [`${prefixCls.value}-${mergedSize.value}`]: mergedSize.value !== 'middle',
        [attrs.class]: !!attrs.class
      }, hashId.value);
      return wrapSSR(_createVNode("div", _objectSpread(_objectSpread({
        "class": collapseClassName
      }, getDataAndAriaProps(attrs)), {}, {
        "style": attrs.style,
        "role": accordion ? 'tablist' : null
      }), [getItems()]));
    };
  }
});